rm(list=ls(all=TRUE))
library(MCMCpack)
library(mvtnorm)
library(tensor)
library(mnormt)
library(rmgarch)
library(gdata)
library(pscl)
M=read.table("data-currency.txt",header=TRUE)
m=log(M)
M=as.matrix(m[300:701,1:3])
obs=diff(M)
plot.ts(obs)
Ti=400#number of Time
dim=3#dimention
mu=matrix(rep(0,dim),nrow=1,ncol=dim)
xs=array(rep(diag(dim),Ti),dim=c(dim,dim,Ti))
A=array(rep(diag(dim),(Ti)),dim=c(dim,dim,Ti))
B=array(rep(diag(dim),(Ti)),dim=c(dim,dim,Ti))
F=array(rep(diag(dim),(Ti+1)),dim=c(dim,dim,Ti+1))
m=array(rep(0,Ti),dim=c(1,Ti))

n=10
Va=diag(dim)
Mua=rep(0,dim)
delta=0.98
k=(delta*(1-dim)+dim)/(delta*(2-dim)+dim-1)
#######when t=1#####


xs[,,1]=riwish(n+dim-1,solve(obs[1,]%*%t(obs[1,])+k*A[,,1]%*%F[,,1]%*%A[,,1]))
F[,,2]=solve(obs[1,]%*%t(obs[1,])+solve(k*A[,,1]%*%F[,,1]%*%A[,,1]))


####when t=2...Ti####
for (t in 2:Ti)
{
Ai=A[,,t-1]
Aj=diag(dim)
repeat{
Top=0
Bot=0

for (h in 1:t)
         {
top=-2*diag((1/k)*solve(Aj)%*%F[,,h]%*%solve(Aj)%*%solve(obs[h,]%*%t(obs[h,])+(1/k)*solve(Aj)%*%F[,,h]%*%solve(Aj))%*%solve(Aj))
bot=matrix(0,nrow=dim,ncol=dim)
            for (i in 1:dim){
                               for(j in 1:dim)
                                              {
ui=diag(dim)[,i]%*%t(diag(dim)[,i])
uj=diag(dim)[,j]%*%t(diag(dim)[,j])
part1=sum(diag(-2*F[i,j,h]*solve(Aj)%*%F[,,h]%*%solve(Aj)+
(Aj%*%solve(F[,,h])%*%ui%*%t(ui)+ui%*%t(ui)%*%solve(F[,,h])%*%Aj)%*%(solve(Aj)%*%F[,,h]%*%solve(Aj))%*%(Aj%*%solve(F[,,h])%*%uj%*%t(uj)+uj%*%t(uj)%*%solve(F[,,h])%*%Aj)%*%solve(Aj)%*%F[,,h]%*%solve(Aj)+
(Aj%*%solve(F[,,h])%*%uj%*%t(uj)+uj%*%t(uj)%*%solve(F[,,h])%*%Aj)%*%(solve(Aj)%*%F[,,h]%*%solve(Aj))%*%(Aj%*%solve(F[,,h])%*%ui%*%t(ui)+ui%*%t(ui)%*%solve(F[,,h])%*%Aj)%*%solve(Aj)%*%F[,,h]%*%solve(Aj)))
part2=-sum(diag((1/k^4)*(Aj%*%solve(F[,,h])%*%ui%*%t(ui)+ui%*%t(ui)%*%solve(F[,,h])%*%Aj)%*%(solve(Aj)%*%F[,,h]%*%solve(Aj))%*%(Aj%*%solve(F[,,h])%*%uj%*%t(uj)+uj%*%t(uj)%*%solve(F[,,h])%*%Aj)%*%solve(Aj)%*%F[,,h]%*%solve(Aj)))
bot[i,j]=part1+part2
                                              }
                             }
Top=top+Top
Bot=bot+Bot
         }
Ai=Aj+(-solve(Va)%*%(Aj-Mua)-k*(delta/(1-delta)+dim)*Top)%*%solve(-solve(Va)-k*(delta/(1-delta)+dim)*Bot)

if (norm(Ai-Aj)<0.01)
               {
                  break
               }
Aj=Ai
m[,t]=m[,t]+1
     }
A[,,t]=Ai
F[,,t+1]=solve(obs[t,]%*%t(obs[t,])+solve(k*A[,,t]%*%F[,,t]%*%A[,,t]))
xs[,,t]=riwish(n+dim-1,solve(F[,,t]))
}

