rm(list=ls(all=TRUE))
library(MCMCpack)
library(mvtnorm)
library(tensor)
library(mnormt)
library(rmgarch)
library(sn)
M=read.table("data2.txt",header=T)
m=log(M)
M=as.matrix(m[1:500,1:2])
obs=diff(M)
plot.ts(obs)
N<-500#number of particles
Ti=499#number of Time
dim=2#dimention
k=5
v=3
mu=matrix(rep(0,dim),nrow=1,ncol=dim)
df=5


###########SMC

ESS<-rep(N/2,Ti)
NESS<-N/2
alpha=array(rep(0,Ti*dim),dim=c(dim,Ti))
phi=array(rep(diag(dim),N*(Ti+1)),dim=c(dim,dim,N,Ti+1))
xs<-array(rep(diag(dim),N*(Ti+1)),dim=c(dim,dim,N,Ti+1))
Weight=array(rep(1/N,N*Ti),dim=c(N,Ti))
A=array(rep(diag(dim),N*(Ti)),dim=c(dim,dim,N,Ti))
beta=diag(dim)
means<-array(rep(0,(dim^2)*Ti),dim=c(dim,dim,Ti))
meanA<-array(rep(0,(dim^2)*(Ti)),dim=c(dim,dim,Ti))
####sr-function
squareroot=function(x)
{
e=eigen(x)
V=e$vectors
B=V %*% diag(sqrt(e$values)) %*% t(V)
B
}
inverse=function(y)
{
e=eigen(y)
V=e$vectors
B=V %*% diag(1/(e$values)) %*% t(V)
B
}
######for t=0##############
####prior for A and x
for (i in 1:N)
{
A[,,i,1]=riwish(v,beta)
repeat{
          xs[,,i,1]=rwish(k,diag(dim))
          if (det(xs[,,i,1])>10^(-6))
         {
        break
         }
      }
}
######for t=1##############

for (i in 1:N)
{
repeat{
          xs[,,i,2]=rwish(k,(1/k)*squareroot(xs[,,i,1])%*% A[,,i,1] %*% squareroot(xs[,,i,1]))
           if (det(xs[,,i,2])>10^(-6))
        {
        break
        }
      }
}
######for t=2...Ti#######

for (i in 1:N)
{
phi[,,,1]=(1/k)*squareroot(xs[,,i,1])%*% t(xs[,,i,2]) %*% squareroot(xs[,,i,1])+beta
}
t<-3
while (t<(Ti+2))
{
####generate A and phi and SMC####
for (i in 1:N)
     {        
      A[,,i,t-1]=riwish(k+(t-2)*v,phi[,,i,t-2])
      phi[,,i,t-1]=(1/k)*squareroot(xs[,,i,t-2])%*% solve(xs[,,i,t-1]) %*% squareroot(xs[,,i,t-2])+phi[,,i,t-2] 
xs[,,i,t]=rwish(k,(1/k)*squareroot(xs[,,i,t-1])%*% A[,,i,t-1] %*% squareroot(xs[,,i,t-1]))
Omega=(((df-2)^2)*(df-4)*inverse(xs[,,i,t])-2*(alpha%*%t(alpha))*df^2)/(df*(df-2)*(df-4))
alpha[,t-1]=0.5*alpha[,t-2]+0.5*obs[t-2,]
Mu=mu+alpha[,t-1]*df/(2-df)
part1=dmst(obs[t-2,],Mu,pd.solve(xs[,,i,t]),alpha[,t-1],df)
part2=(dwish(xs[,,i,t],k+1,obs[t-2,]%*%t(obs[t-2,])+(1/k)*squareroot(xs[,,i,t-1])%*% A[,,i,t-1] %*% squareroot(xs[,,i,t-1])))
part3=(dwish(xs[,,i,t],k,(1/k)*squareroot(xs[,,i,t-1])%*% A[,,i,t-1] %*% squareroot(xs[,,i,t-1])))
Weight[i,t-1]=Weight[i,t-2]*part1*part2/part3
     }
      Weight[,t-1]=Weight[,t-1]/sum(Weight[,t-1])
      ESS[t-2]=1/sum(Weight[,t-1]^2)
    if (ESS[t-2]<NESS)
	   {
               index=sample(N,N,replace=TRUE,prob=Weight[,t-1])
                xs[,,,t]=xs[,,index,t]
               Weight[,t-1]=rep(1/N,N)
          }      
t=t+1
}


